package com.ef_prime.rflow;

import com.ef_prime.rflow.util.TypeDefProperties;

/**
 * .rflowファイルごとの設定です
 *
 */
public class FlowSetting extends TypeDefProperties{
	public static enum Key implements TypeDefProperties.Key{
		/**
		 * グリッドのon/off
		 */
		USE_GRID(Type.BOOLEAN, true),
		
		/**
		 * グリッドの幅
		 */
		GRID_DISTANCE(Type.INTEGER, 10);
		
		private Object defaultValue;
		private Type type;
		
		private Key(Type type, Object defaultValue){
			this.defaultValue = defaultValue;
			this.type = type;
		}

		public Object getDefaultValue() {
			return defaultValue;
		}

		public Type getType() {
			return type;
		}
		
		public String getKeyString() {
			return toString();
		}
	}
	

	public static FlowSetting createDefaultSettings()
	{
		FlowSetting def = (FlowSetting)setDefaultProperties(new FlowSetting(), Key.values());
		//デフォルト値をSettingから取得
		def.setProperty(Key.USE_GRID, Rflow.setting.getProperty(Setting.Key.USE_GRID));
		def.setProperty(Key.GRID_DISTANCE, Rflow.setting.getProperty(Setting.Key.GRID_DISTANCE));
		return def;
	}

	public void update(){
		update(Key.values());
	}
}
