package com.ef_prime.rflow.explorer;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import com.ef_prime.rflow.Rflow;
import com.ef_prime.rflow.resource.Messages;

public class Explorer extends JPanel{
	
	private JTabbedPane tabbedPane;

	private FileExplorer fileExplorer;
	private FunctionExplorer functionExplorer;
	
	public Explorer(Rflow rflow){
		super();
		setLayout(new BorderLayout());
		
		fileExplorer = new FileExplorer(rflow);
		functionExplorer = new FunctionExplorer(rflow);
		
		tabbedPane = new JTabbedPane();
		tabbedPane.add(fileExplorer, Messages.getString("Explorer.file")); //$NON-NLS-1$
		tabbedPane.add(functionExplorer, Messages.getString("Explorer.function")); //$NON-NLS-1$
		//tabbedPane.add(new PartsExplorerPanel(rflow), "パーツ");
		
		add(tabbedPane);
	}
	
	public FunctionExplorer getFunctionExplorer() {
		return functionExplorer;
	}
	
	public FileExplorer getFileExplorer() {
		return fileExplorer;
	}
	
	/*public PartsExplorerPanel getPartsExplorerPanel() {
		return (PartsExplorerPanel)tabbedPane.getComponent(1);
	}*/
}
