package com.ef_prime.rflow.flow;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.util.List;

import com.ef_prime.rflow.CommandReceiver;
import com.ef_prime.rflow.RCommand;
import com.ef_prime.rflow.flow.model.FlowNode;

public class FlowExecuter {
	
	private CommandReceiver receiver;
	private FlowState state;
	
	public FlowExecuter(CommandReceiver receiver, FlowState state){
		this.receiver = receiver;
		this.state = state;
	}
	

	public void execute(final FlowNode invokeNode){
		this.execute(invokeNode, false);
	}
	
	public void execute(final FlowNode invokeNode, boolean clearObjects){
		if(clearObjects)
			RCommand.clearObjects();
		
		List<FlowNode> stream = FlowUtil.getStream(invokeNode);
		
		for(FlowNode node : stream){
			receiver.passCommand(node.getModel().getCommand());
		}
	}
	
	public void excuteRest(final FlowNode invokeNode){
		List<FlowNode> stream = FlowUtil.getStream(invokeNode);

		//フラグノードの次のノードインデックスを取得
		int startIndex = 0;
		for(FlowNode node : stream){
			startIndex++;
			if(state.isFlagNode(node))
				break;			
		}
		if(startIndex >= stream.size())startIndex = 0;
		
		for(int i = startIndex; i < stream.size(); i++){
			receiver.passCommand(stream.get(i).getModel().getCommand());
		}
	}
	
	public void excuteInLocal(final FlowNode invokeNode){		
		List<FlowNode> stream = FlowUtil.getStream(invokeNode);

		//フラグノードの次のノードインデックスを取得
		int startIndex = 0;
		for(FlowNode node : stream){
			startIndex++;
			if(state.isFlagNode(node))
				break;			
		}
		if(startIndex >= stream.size())startIndex = 0;
		
		for(int i = startIndex; i < stream.size(); i++){
			FlowNode node = stream.get(i);
			String command = node.getModel().getCommand();
			receiver.passCommand(RCommand.getLocalExcutionCode(command));
			//RCommand.getR().eval(RCommand.getLocalExcutionCode(command));
			//RCommand.getR().jriWriteConsole(command);
		}
	}
	
	public void copyCommandToClipBoard(FlowNode invokeNode){
		List<FlowNode> stream = FlowUtil.getStream(invokeNode);

		String command = FlowUtil.getCommandFromStream(stream, false);
		
		Clipboard clip = Toolkit.getDefaultToolkit().getSystemClipboard();
		StringSelection s = new StringSelection(command);
		clip.setContents(s, s);
	}
}
