package com.ef_prime.rflow.flow;

import com.ef_prime.rflow.flow.model.FlowNode;

public class NodeSelectionInfo {
	private FlowNode in;
	private FlowNode out;

	private FlowNode source;

	public NodeSelectionInfo(FlowNode in, FlowNode out, FlowNode source) {
		if(in == null || out == null || source == null)
			throw new IllegalArgumentException("in, out or source can't be null."); //$NON-NLS-1$
		
		this.in = in;
		this.out = out;
		this.source = source;
	}

	public FlowNode getIn() {
		return in;
	}

	public FlowNode getOut() {
		return out;
	}

	public FlowNode getSource() {
		return source;
	}
	
	@Override
	public int hashCode() {
		return in.hashCode()+out.hashCode()+source.hashCode();
	}
	
	@Override
	public boolean equals(Object obj) {
		if(this == obj)return true;
		if(!(obj instanceof NodeSelectionInfo))return false;
		NodeSelectionInfo info = (NodeSelectionInfo)obj;
		return 	(in.equals(info.getIn())
				&&(out.equals(info.getOut()))
				&&(source.equals(info.getSource())));
	}
}
