package com.ef_prime.rflow.node;

import java.awt.Image;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;

import com.ef_prime.rflow.exception.InvalidOptionException;

public abstract class ArgComponent extends JPanel{
	
	private String param;
	
	private boolean isOperative;
	private JLabel operativeLabel;
	
	private Vector<ArgComponent> list;
	
	public ArgComponent(String param){
		this.param = param;
	}
	
	public String getParameter(){
		return param;
	}
	
	public boolean hasChild(){
		return list != null && list.size() > 0;
	}
	
	public Iterator<ArgComponent> children(){
		if(!hasChild())
			return null;
		return list.iterator();
	}
	
	public void addArgumentComponent(ArgComponent ac){
		if(list == null)
			list = new Vector<ArgComponent>(2);
		list.add(ac);
	}
	
	public abstract String getValue() throws InvalidOptionException;
	public abstract void setValue(String value);
	
	public boolean isOperative() {
		return isOperative;
	}
	
	public void setOperative(boolean isOperative) {
		this.isOperative = isOperative;
		getOperativeLabel().setVisible(!isOperative);
	}
	
	public JLabel getOperativeLabel() {
		if(operativeLabel == null){
			ImageIcon icon = (ImageIcon)UIManager.getIcon("OptionPane.errorIcon");
			icon = new ImageIcon(icon.getImage().getScaledInstance(16, 16, Image.SCALE_SMOOTH));
			operativeLabel = new JLabel(icon);
			operativeLabel.setToolTipText("ＧＵＩで表現できない値が設定されています。");
		}
		return operativeLabel;
	}
	
	public static ArgComponent createNoParamArgumentComponent(){
		return new ArgComponent(null){
			@Override
			public String getValue() throws InvalidOptionException {
				return null;
			}
			@Override
			public void setValue(String value) {
			}
		};
	}
}
