package com.ef_prime.rflow.node;

import java.util.Properties;

import com.ef_prime.rflow.exception.CanceledException;
import com.ef_prime.rflow.exception.ModelCreationFailedException;

public interface NodeModelController {
	
	String getModelName();
	
	Class<? extends NodeModel> getModelClass();
	
	/**
	 * 新しいモデルを作成する
	 * @return
	 * @throws CanceledException
	 */
	NodeModel createNewModel() throws CanceledException;
	
	/**
	 * orgModelから新しいモデルを作成する
	 * @param orgModel
	 * @return
	 * @throws CanceledException
	 */
	NodeModel getNodeModel(NodeModel orgModel) throws CanceledException;
	
	/**
	 * modelの設定Propertiesをかえす
	 * @param model
	 * @return
	 */
	Properties getOptionProperties(NodeModel model);
	
	NodeModel createModel(Properties properties, String title, String command) throws ModelCreationFailedException;

	//boolean checkModelClass(NodeModel model);
	
	boolean isAddable();
}
