package com.ef_prime.rflow.node.base;

import com.ef_prime.rflow.Constants;
import com.ef_prime.rflow.node.AbstractNodeModel;
import com.ef_prime.rflow.node.NodeModel;

public class FreeNodeModel extends AbstractNodeModel{

	public String command = ""; //$NON-NLS-1$
	
	public FreeNodeModel(){}
	
	public FreeNodeModel(String title, String command){
		setTitle(title);
		this.command = command;
	}
	
	private FreeNodeModel(FreeNodeModel model) {
		super(model);
		command = model.command;
	}

	public String getCommand() {
		if(!command.endsWith(Constants.NEWLINE_STR))
			return command + Constants.NEWLINE_STR;
		return command;
	}
	
	@Override
	protected String getDefaultTitle() {
		String omitted = command.replaceAll("\n", " "); //$NON-NLS-1$ //$NON-NLS-2$
		if(omitted.length() > 10)
			omitted = omitted.substring(0, 10)+"..."; //$NON-NLS-1$
		return omitted;
		//return "FREE";
	}
	
	public NodeModel copy(){
		return new FreeNodeModel(this);
	}

	@Override
	public int hashCode() {
		return super.hashCode();
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof FreeNodeModel) {
			return super.equals(obj);
		}
		return false;
	}
}
