package com.ef_prime.rflow.node.base;

import java.awt.Shape;
import java.awt.Window;
import java.awt.geom.Ellipse2D;

import com.ef_prime.rflow.exception.CanceledException;
import com.ef_prime.rflow.flow.rendering.NodeShape;
import com.ef_prime.rflow.node.AbstractNodeModel;
import com.ef_prime.rflow.node.NodeModel;

public class TunnelNodeModel extends AbstractNodeModel{
	
	private static final Shape ellipseShape = 
		new Ellipse2D.Double(-NodeShape.DEFAULT_SIZE/4,-NodeShape.DEFAULT_SIZE/2,
				NodeShape.DEFAULT_SIZE/2,NodeShape.DEFAULT_SIZE);
	
	private int type;
	private static final int IN = 0;
	private static final int OUT = 1;
	
	public static final TunnelNodeModel inModel = new TunnelNodeModel(IN);
	public static final TunnelNodeModel outModel = new TunnelNodeModel(OUT);
	
	private TunnelNodeModel(int type){
		this.type = type;
	}
	
	/*	
	public static TunnelNodeModel getInTunnelModel(){
		if(inModel == null)
			inModel = new TunnelNodeModel(IN);
		return inModel;
	}
	
	public static TunnelNodeModel getOutTunnelModel(){
		if(outModel == null)
			outModel = new TunnelNodeModel(OUT);
		return outModel;
	}*/
	
	
	@Override
	public NodeModel showConfigDialog(Window parent) throws CanceledException {
		throw new CanceledException();
	}

	public String getCommand() {
		return ""; //$NON-NLS-1$
	}

	@Override
	protected String getDefaultTitle() {
		switch(type){
		case IN:return "in";
		case OUT:return "out";
		default:return null;
		}
	}
	
	@Override
	public void setTitle(String title) {
		throw new UnsupportedOperationException();
	}
	
	@Override
	public Shape getShape() {
		return ellipseShape;
	}
	
	public boolean isInModel(){
		return type == IN;
	}
	
	public boolean isOutModel(){
		return type == OUT;
	}

	@Override
	public NodeModel copy() {
		return this;
	}
	
	@Override
	public int hashCode() {
		return super.hashCode();
	}
	
	@Override
	public boolean equals(Object obj) {
		return this == obj && super.equals(obj);
	}
}
