package com.ef_prime.rflow.tool;

import java.awt.Dimension;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;

import com.ef_prime.rflow.resource.Messages;

public class ButtonPanel extends JPanel{
	
	private JButton ok;
	private JButton cancel;
	private Dimension buttonSize;
	
	public ButtonPanel(ActionListener okAction, 
			ActionListener cancelAction)
	{
		this(okAction, cancelAction, new Dimension(80, 25));
	}

	public ButtonPanel(ActionListener okAction, 
			ActionListener cancelAction,
			Dimension buttonSize)
	{
		this(okAction, cancelAction, 
				Messages.getString("Button.ok"),  //$NON-NLS-1$
				Messages.getString("Button.cancel"), //$NON-NLS-1$
				buttonSize);
	}
	
	
	public ButtonPanel(ActionListener okAction, 
			ActionListener cancelAction,
			String okLabel,
			String cancelLabel,
			Dimension buttonSize)
	{
		super();
		this.buttonSize = buttonSize;
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		
		
		
		ok = createButton(okLabel);
		ok.addActionListener(okAction);
		cancel = createButton(cancelLabel);
		cancel.addActionListener(cancelAction);
		
		add(ok);
		add(Box.createHorizontalStrut(50));
		add(cancel);
	}
	
	public JButton getOkButton() {
		return ok;
	}
	
	public JButton getCancelButton() {
		return cancel;
	}
	
	JButton createButton(String title){
		JButton button = new JButton(title);
		button.setPreferredSize(buttonSize);
		button.setMaximumSize(buttonSize);
		
		return button;
	}
}
