package com.ef_prime.rflow.util;

import java.awt.Component;
import java.awt.FontMetrics;
import java.awt.event.MouseListener;

import javax.swing.JTextPane;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.TabSet;
import javax.swing.text.TabStop;

public class SwingUtils {
	
	public static void insertMouseListener(Component c, MouseListener listener){
		MouseListener[] listeners = c.getMouseListeners();
		for(MouseListener l : listeners)
			c.removeMouseListener(l);
		
		c.addMouseListener(listener);

		for(MouseListener l : listeners)
			c.addMouseListener(l);
	}
	
	public static void setTabs(JTextPane textPane, int charactersPerTab)
	{
		FontMetrics fm = textPane.getFontMetrics(textPane.getFont());
		int charWidth = fm.charWidth('w');
		int tabWidth = charWidth * charactersPerTab;
 
		TabStop[] tabs = new TabStop[10];
 
		for (int j = 0; j < tabs.length; j++)
		{
			int tab = j + 1;
			tabs[j] = new TabStop( tab * tabWidth );
		}
 
		TabSet tabSet = new TabSet(tabs);
		SimpleAttributeSet attributes = new SimpleAttributeSet();
		//MutableAttributeSet attributes = (MutableAttributeSet)getParagraphAttributes();
		StyleConstants.setTabSet(attributes, tabSet);
		//attributes.setResolveParent(new SimpleAttributeSet(getParagraphAttributes()));
		
		textPane.setParagraphAttributes(attributes, false);
	}
}
